////////////////////////////////////////////////////////////////////////
//
// 46-927 Data Structures, Algorithms and AI
//
// File: Key.cpp
//
// Author:        Jeff Stephenson        
// Date:          August 22, 1998  
// Comments:      Implementation of the CKey class 
//
//                See CKey.h for more detail.
// 
////////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include "Key.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CKey::CKey()
{
    m_time = 0;
    m_stock_price = 0;
    m_aux_process = 0;
    m_option_value = 0;
}


CKey::CKey(int pTime, double pPrice, double pProcess)
{
    m_time = pTime;
    m_stock_price = pPrice;
    m_aux_process = pProcess;
    m_option_value = 0;
}


CKey::~CKey()
{
    
}

//////////////////////////////////////////////////////////////////////
// Printing Function
//////////////////////////////////////////////////////////////////////
void CKey::PrintKey()
{
    cout << "Time:  " << m_time; 
    cout << "  Stock Price:  " << m_stock_price;
    cout << "\tAux Process:  " << m_aux_process;
    cout << "\tOption Value:  " << m_option_value;
    cout << endl;

}

//////////////////////////////////////////////////////////////////////
// Tests for Equality
// Returns:  True if keys are equal, False otherwise
//////////////////////////////////////////////////////////////////////
bool CKey::IsEqual(CKey aKey)
{
    bool areEqual = false;

    if ((aKey.GetTime() == m_time) && 
       (aKey.GetStockPrice() == m_stock_price) &&
       (aKey.GetAuxProcess() == m_aux_process) &&
        (aKey.GetOptionValue() == m_option_value))
    {
        areEqual = true;
    }
   

    return areEqual;

}

//////////////////////////////////////////////////////////////////////
// Accessor functions
//////////////////////////////////////////////////////////////////////
int CKey::GetTime()
{
    return m_time;
}


void CKey::SetTime(int pTime)
{
    m_time = pTime;
}

double CKey::GetStockPrice()
{
    return m_stock_price;
}

void CKey::SetStockPrice(double pPrice)
{
    m_stock_price = pPrice;
}

double CKey::GetAuxProcess()
{
    return m_aux_process;
}

void CKey::SetAuxProcess(double pProcess)
{
    m_aux_process = pProcess;
}

double CKey::GetOptionValue()
{
    return m_option_value;
}

void CKey::SetOptionValue(double pOptValue)
{
    m_option_value = pOptValue;
}


//////////////////////////////////////////////////////////////////////
// Override of the equal operator
//////////////////////////////////////////////////////////////////////
CKey&  CKey::operator=(const CKey& aKey)
{

    this->m_time = aKey.m_time;
    this->m_stock_price = aKey.m_stock_price;
    this->m_aux_process = aKey.m_aux_process;
    this->m_option_value = aKey.m_option_value;
		

    return *this;

}




