////////////////////////////////////////////////////////////////////////
//
// 46-927 Data Structures, Algorithms and AI
// Homework Assignment #1
//
// File: Node.cpp
//
// Author:        Jeff Stephenson        
// Date:          August 22, 1998  
// Comments:      Supporting Code for Assignment #1
//                Implementation of the CNode class
//
//                See Node.h
// 
////////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <assert.h>
#include "Node.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNode::CNode(CKey aKey)
{
    int i = 0;

    m_next = NULL;
    m_prev = NULL;
    m_data = aKey;

    for (i=0; i<NO_OF_SUCC; i++)
    {
        m_succ[i] = NULL;
    }
}

CNode::~CNode()
{

}

//////////////////////////////////////////////////////////////////////
// Accessor Functions
//////////////////////////////////////////////////////////////////////

CNode* CNode::GetNext()
{
    return m_next;
}

void CNode::SetNext(CNode* aNode)
{
    m_next = aNode;
}

CNode* CNode::GetPrev()
{
    return m_prev;
}

void CNode::SetPrev(CNode* aNode)
{
    m_prev = aNode;
}


CKey CNode::GetData()
{
   return m_data;
}

void CNode::SetData(CKey aKey)
{   
    m_data = aKey;
}


//Returns the CNode* stored in the m_succNum position of
//the m_succ array
CNode* CNode::GetSuccessor(int succNum)
{
    if ((succNum >= 0) && (succNum < NO_OF_SUCC))
    {
        return m_succ[succNum];
    }
    
    return NULL;
}

bool CNode::SetSuccessor(int succNum, CNode* succ)
{
    bool success = false;

    if ((succNum >= 0) && (succNum < NO_OF_SUCC))
    {
        m_succ[succNum] = succ;
        success = true;
    }

    return success;
}

//////////////////////////////////////////////////////////////////////
// Printing Function
//////////////////////////////////////////////////////////////////////
void CNode::PrintNode()
{

    m_data.PrintKey();

}