////////////////////////////////////////////////////////////////////////
//
// 46-927 Data Structures, Algorithms and AI
// Homework Assignment #1
//
// File: Node.h
//
// Author:        Jeff Stephenson        
// Date:          August 22, 1998  
// Comments:      Supporting Code for Assignment #1
//                Declaration of the CNode class (one node of a CLinkedList)
//                See Node.cpp
//
//                For the option calculator, we've added an array of
//                successors for each node to implement the lattice:
//
//                CNode* m_succ[NO_OF_SUCC];
//
//                We're using the binomial model, so we've fixed
//                NO_OF_SUCC at 2.  Use the new functions GetSuccessor()
//                and SetSuccessor() to access the m_succ array.
//
//                The m_next and m_prev pointers point to nodes at
//                the same time value as this node
//                
// 
////////////////////////////////////////////////////////////////////////


#ifndef NODE_H
#define NODE_H

#include "Key.h"


//No of successors of this node
//initially this is only 2 because
//of the binomial model
#define NO_OF_SUCC 2


class CNode  
{
public:
	CNode(CKey aKey);
	virtual ~CNode();

    CNode* GetNext();
    void   SetNext(CNode* aNode);

    CNode* GetPrev();
    void   SetPrev(CNode* aNode);

    CKey   GetData();
    void   SetData(CKey aKey);

    CNode* GetSuccessor(int succNum);
    bool   SetSuccessor(int succNum, CNode* succ);

    void   PrintNode();

protected:

    CNode* m_next;
    CNode* m_prev;
    CKey   m_data;
    CNode* m_succ[NO_OF_SUCC];

};

#endif 
